﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

// new
using System.IO;
using System.Runtime.InteropServices;


namespace FM4500 {
    public partial class FEditor : Form {

        //private MyTextBox _editor = new MyTextBox();
        private String _actualDirectory = "";

        private String _content;

        private String sFilename = "";

        public FEditor(String content) {
            InitializeComponent();
            _content = content;
        }

        private void FEditor_Load(object sender, EventArgs e) {
            _actualDirectory = Environment.CurrentDirectory;
            tableLayoutPanel1.ColumnCount = 1;
            tableLayoutPanel1.RowCount = 2;
            tableLayoutPanel1.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 100F));

            tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 100F));
            tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle());

            tableLayoutPanel1.Dock = DockStyle.Fill;

            tableLayoutPanel1.Dock = DockStyle.Fill;
            flowLayoutPanel1.Dock = DockStyle.Fill;
            flowLayoutPanel1.AutoSize = true;


            lColumn.Margin = new System.Windows.Forms.Padding(8, 0, 4, 0);  // left top right bottom
            lDateiname.Margin = new System.Windows.Forms.Padding(8, 0, 4, 0);  // left top right bottom

            lRow.Text = "Row: ";
            lColumn.Text = "Col: ";
            lDateiname.Text = "Name: ";

            editor.Dock = DockStyle.Fill;
            mnWordWrap.Checked = false;
            editor.Font = new Font("Verdana", 10);
            mnFontsize10pg.Checked = true;

            editor.Text = _content;
            editor.SelectionStart = 0;
            timer1.Enabled = true;

        }


        public String getLine(int row, String text) {
            StringBuilder sb = new StringBuilder();
            string[] splitStrings = { "\r\n" };
            string[] lines = text.Split(splitStrings, StringSplitOptions.None);
            if (row > 0 && row <= lines.Length) {
                return lines[row - 1];
            }
            else {
                return "Fehler in Modul getLine";
            }
        }

        public int getLinenr(int rowindex, String text) {
            StringBuilder sb = new StringBuilder();
            string[] splitStrings = { "\r\n" };  // { "\r", "\r\n", "\n" };
            string[] lines = text.Split(splitStrings, StringSplitOptions.None);
            int rowChars = 0;
            for (int i = 0; i < lines.Length - 1; i++) {
                String sLine = lines[i];
                if (rowindex < rowChars) {
                    return i;
                }
                rowChars += lines[i].Length + 2;
            }
            return lines.Length;
        }

        private void setCursor() {
            int lineindex = editor.GetFirstCharIndexOfCurrentLine();
            int linecount = getLinenr(lineindex, editor.Text);
            int columnCount = editor.SelectionStart - lineindex + 1;
            this.lRow.Text = "Zl: " + linecount;
            this.lColumn.Text = "Sp: " + columnCount;
        }
        // the Timer call this methods
        private void editor_TextChanged(object sender, EventArgs e)
        {
            setCursor();
        }

       
        private void checkFile()
        {
            if (editor.Modified)
            {
                DialogResult res = Basis.readYesNoCancel("Sollen die Änderungen im Editor gespeichert werden?", "Datei laden");
                switch (res)
                {
                    case DialogResult.Yes: saveFile();
                        break;
                    case DialogResult.No:
                        break;
                    case DialogResult.Cancel:
                        break;
                }
            }
        }

        private void loadFilename(String sFilename)
        {
            checkFile();
            string sStr;
            FileStream oFile = new FileStream(sFilename, FileMode.Open);
            StreamReader inStream = new StreamReader(oFile);
            sStr = inStream.ReadToEnd();
            editor.Text = sStr;
            inStream.Close();
            oFile.Close();
            editor.Modified = false;
            editor.SelectionStart = 0;  // set the cursor to the begin of the text
            editor.SelectionLength = 0;
            lDateiname.Text = sFilename;
            Text = "Editor: "+sFilename;
        }

        private void saveFile()
        {
            FileStream oFile;
            StreamWriter oStream;
            if (!sFilename.Equals(""))
            {
                oFile = new FileStream(sFilename, FileMode.Create);
                oStream = new StreamWriter(oFile);
                oStream.WriteLine(editor.Text);
                oStream.Close();
                oFile.Close();
            }
            editor.Modified = false;
        }  // saveFile


        private void mnOpen_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFileDialog1 = new OpenFileDialog();
            openFileDialog1.Filter = "Text-Dateien (*.txt,dat)|*.txt;*.dat|XML-Dateien (*.xml)|*.xml|Alle Dateien (*.*)|*.*";
            openFileDialog1.FilterIndex = 1;// zählt von 1 !
            openFileDialog1.DefaultExt = ".txt";
            openFileDialog1.InitialDirectory = Environment.CurrentDirectory;
            openFileDialog1.Multiselect = false;
            openFileDialog1.RestoreDirectory = true;
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                sFilename = openFileDialog1.FileName.ToString();    
                loadFilename(sFilename);
                this.Text = sFilename;
            }

        }

        private void mnSave_Click(object sender, EventArgs e)
        {
            if (sFilename.Equals(""))
            {
                mnSaveAs_Click(sender, e);
            }
            else
            {
                saveFile();
            }
        }

        private void mnSaveAs_Click(object sender, EventArgs e)
        {
            SaveFileDialog saveFileDialog1 = new SaveFileDialog();
            saveFileDialog1.Title = "Speichern unter";
            saveFileDialog1.Filter = "Text-Dateien (*.txt,dat)|*.txt;*.dat|XML-Dateien (*.xml)|*.xml|Alle Dateien (*.*)|*.*";
            saveFileDialog1.FilterIndex = 1;// zählt von 1 !
            saveFileDialog1.DefaultExt = ".txt";
            saveFileDialog1.InitialDirectory = Environment.CurrentDirectory;
            saveFileDialog1.RestoreDirectory = true;
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                // Verarbeitung        
                sFilename = saveFileDialog1.FileName.ToString();
                this.Text = sFilename;
                saveFile();
            }

        }
        

        private void mnNew_Click(object sender, EventArgs e)
        {
            sFilename = "";
            editor.Text = "";
            editor.Modified = false;
        }

        private void mnClose_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void mnCopy_Click(object sender, EventArgs e)
        {
            editor.Copy();
        }

        private void mnCut_Click(object sender, EventArgs e)
        {
            editor.Cut();
        }

        private void mnPaste_Click(object sender, EventArgs e)
        {
            editor.Paste();
        }

        private void mnSelectAll_Click(object sender, EventArgs e)
        {
            editor.SelectAll();
        }


        private void mnWordWrap_Click(object sender, EventArgs e)
        {
            mnWordWrap.Checked = ! mnWordWrap.Checked;
            editor.WordWrap = mnWordWrap.Checked;
        }

      
        private const int EM_SETTABSTOPS = 0x00CB;

        [DllImport("User32.dll", CharSet = CharSet.Auto)]
        // public static extern IntPtr SendMessage(IntPtr h, int msg, int wParam, int[] lParam);

        public static extern IntPtr SendMessage(IntPtr hWnd, UInt32 Msg, IntPtr wParam, ref int lParam);

        public static void setTabWidth(TextBox textbox, int tabWidth)
        {
            int w;
            Graphics graphics = textbox.CreateGraphics();
            //var characterWidth = (int)graphics.MeasureString("M", textbox.Font).Width;
            //w = tabWidth * characterWidth;
            w = tabWidth;
            SendMessage(textbox.Handle, EM_SETTABSTOPS, new IntPtr(1), ref w);

            //EM_SETTABSTOPS - http://msdn.microsoft.com/en-us/library/bb761663%28VS.85%29.aspx
            textbox.Invalidate();
        }

        private void tabwidth_TextChanged(object sender, EventArgs e)
        {
            //int pixelsize = Convert.ToInt32(tabwidth.Text);
            //setTabWidth(editor, pixelsize);
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (editor.Modified)
            {
                DialogResult res = Basis.readYesNoCancel("Sollen die Änderungen gespeichert werden?"+"\r\nDateiname: "+sFilename, "Programm beenden");
                switch (res)
                {
                    case DialogResult.Yes: saveFile();
                        break;
                    case DialogResult.No:
                        break;
                    case DialogResult.Cancel: e.Cancel = true;
                        break;
                }
            }            
        }

     


        private void editor_KeyPress(object sender, KeyPressEventArgs e) {
            setCursor();
        }

        private void editor_MouseDown(object sender, MouseEventArgs e) {
            setCursor();
        }

        private void setFontsize(ToolStripMenuItem mnFontsize) {
            mnFontsize8pg.Checked = false;
            mnFontsize10pg.Checked = false;
            mnFontsize12pg.Checked = false;
            mnFontsize14pg.Checked = false;
            mnFontsize16pg.Checked = false;
            mnFontsize18pg.Checked = false;
            mnFontsize20pg.Checked = false;
            mnFontsize24pg.Checked = false;
            mnFontsize22pg.Checked = false;
            mnFontsize.Checked = true;
        }

        private void mnFontsize_click(object sender, EventArgs e) {
            ToolStripMenuItem mnFontsize = (ToolStripMenuItem)sender;
            String sSize = (String)mnFontsize.Tag;
            int size = Convert.ToInt32(sSize);
            editor.Font = new Font("Verdana", size);
            setFontsize(mnFontsize);
        }

       
   
    }
}
