﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.IO;

namespace FM4500 {
    public partial class FReadProg : Form {

        private bool retcode = false;

        public bool Retcode {
            get { return retcode; }
        }


        public String Bez {
            get { return tBez.Text.Trim(); }
        }
        public String Prog {
            get { return tProg.Text.Trim(); }
        }
        public FReadProg(Form parent, String bez, String path) {
            InitializeComponent();
            this.Owner = parent;  // Important, because CenterOwner       
            this.StartPosition = FormStartPosition.CenterParent;
            tBez.Text = bez;
            tProg.Text = path;
        }

        private void FReadProg_Load(object sender, EventArgs e) {

        }

        private void bnOk_Click(object sender, EventArgs e) {
            if (tBez.Text.Trim().Length == 0) {
                Basis.ErrorMsg("Geben Sie bitte eine Bezeichnung ein", "Hinweis");
                tBez.Focus();
                return;
            }
            if (tProg.Text.Trim().Length == 0) {
                Basis.ErrorMsg("Geben Sie bitte ein Programm ein", "Hinweis");
                tProg.Focus();
                return;
            }
            if (!File.Exists(tProg.Text.Trim())) {
                Basis.ErrorMsg("Das Programm existiert nicht", "Hinweis");
                tProg.Focus();
                return;
            }
            retcode = true;
            Close();
        }

        private void bnEsc_Click(object sender, EventArgs e) {
            Close();
        }

        private void bnSelectFolder_Click(object sender, EventArgs e) {
            OpenFileDialog openFileDialog = new OpenFileDialog();
            openFileDialog.InitialDirectory = Environment.CurrentDirectory;
            openFileDialog.Filter = "Programm (*.exe)|*.exe|Word-Dateien (*.doc?)|*.doc?|Excel-Dateien (*.xls?)|*.xls?|Alle Dateien (*.*)|*.*";
            if (openFileDialog.ShowDialog(this) == DialogResult.OK) {
                tProg.Text = openFileDialog.FileName;
            }
        }
    }
}
