﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.IO;

namespace FM4500 {
    public partial class FShowDriveSpace : Form {
        private String _lw = "";

        public FShowDriveSpace(Form parent, String lw) {
            InitializeComponent();
            this.Owner = parent;  // Important, because CenterOwner            
            this.StartPosition = FormStartPosition.CenterParent; 
            _lw = lw;
        }

        private void FShowDriveSpace_Load(object sender, EventArgs e) {
            setGUI();
        }

        private void setGUI() {
            tableLayoutPanel1.Dock = DockStyle.Fill;
            tabControl1.Dock = DockStyle.Fill;
            DriveInfo[] drives = DriveInfo.GetDrives();
            int index = -1;
            foreach (DriveInfo drv in drives) {
                String typ = "";
                // check, if node1 ist drive c ?
                switch (drv.DriveType) {
                    case DriveType.CDRom: typ = "CD/DVD:"; break;
                    case DriveType.Fixed: typ = "Platte:"; break;
                    case DriveType.Network: typ = "Netz:"; break;
                    case DriveType.Ram: typ = "Ram:"; break;
                    case DriveType.Removable: typ = "USB:"; break;
                    case DriveType.Unknown: typ = "?:"; break;
                }
                DrivesProperty frame = new DrivesProperty();
                frame.Dock = DockStyle.Fill;
                String header;
                double free;
                if (drv.IsReady) {
                    frame.Ldrive2 = drv.Name;
                    frame.LBez2 = drv.VolumeLabel;
                    frame.LTyp2 = typ;
                    frame.Lfilessystem2 = drv.DriveFormat;
                    frame.lClustersize2 = Basis.Long_Str_Komma(Basis.GetCluster(drv.Name)) + " Bytes";
                    frame.Lgesamt2 = Basis.Long_Str_Komma(drv.TotalSize) + " Bytes";
                    frame.Lgesamt3 = Basis.Best_KB(drv.TotalSize);
                    frame.Lfreier2 = Basis.Long_Str_Komma(drv.AvailableFreeSpace) + " Bytes";
                    frame.Lfreier3 = Basis.Best_KB(drv.AvailableFreeSpace);
                    frame.Lbelegt2 = Basis.Long_Str_Komma(drv.TotalSize - drv.AvailableFreeSpace) + " Bytes";
                    frame.Lbelegt3 = Basis.Best_KB(drv.TotalSize - drv.AvailableFreeSpace);
                    free = (double)drv.AvailableFreeSpace / drv.TotalSize;

                    header = drv.Name + " (" + drv.VolumeLabel + ")";
                }
                else {
                    header = drv.Name;
                    frame.Ldrive2 = drv.Name;
                    frame.LBez2 = "";
                    frame.LTyp2 = typ;
                    frame.Lfilessystem2 = "";
                    frame.lClustersize2 = "0 Bytes";
                    frame.Lgesamt2 = "0 Bytes";
                    frame.Lgesamt3 = "0 Bytes";
                    frame.Lfreier2 = "0 Bytes";
                    frame.Lfreier3 = "0 Bytes";
                    frame.Lbelegt2 = "0 Bytes";
                    frame.Lbelegt3 = "0 Bytes";
                    free = 0;
                }
                frame.Free = free;
                TabPage tabitem = new TabPage();
                tabitem.Text = header;
                tabitem.Controls.Add(frame);
                tabControl1.Controls.Add(tabitem);
                if (drv.Name.Equals(_lw)) {
                    index = tabControl1.Controls.Count - 1;
                }
            } // foreach
            if (index >= 0) {
                tabControl1.SelectedIndex = index;
            }
        } // setgUI

        private void bnOk_Click(object sender, EventArgs e) {
            Close();
        }


    }
}
