﻿nusing System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.IO;

using System.Windows;

using System.Diagnostics;
using System.ComponentModel;
using System.Windows.Forms;
using System.Collections;



namespace FM4500 {
    public class MyListView : ListView {

        private int _headerClicked = -1;
        private int _lastHeaderClicked = -1;

        private Middleware _middleware = Middleware.getInstance();
        private Form _parent;
        private IFileManager _parentClass;

        private List<FileItem> _fileliste = new List<FileItem>();

        private char _abc = ' ';  // for the search modus
        private int _abcIndex = -1;
        private bool _abcChange = false;

        private FileSystemWatcher _fsw;

        private Konstanten.setFilenamePath sFP;

        private String _actualPath = "";

        TabControl _tabControl = null;
        TabPage _tabitem=null;

        public Middleware.Masken _aktmask = Middleware.Masken.Stern;
        public String _OwnerDefined = ""; // variable for the mask, samples:  java;cs;pas

        private ContextMenuStrip contextMenuStrip;
        private ToolStripMenuItem _mnMainProg;
        private ToolStripMenuItem _mnMainFavoriten;

        public List<FileItem> Fileliste {
            get { return _fileliste; }
        }

        public String ActualPath {
            get { return _actualPath; }
            set {
                if (value.Length > 0) {
                    _actualPath = value;
                    _tabitem.Text =  Basis.HeaderFolder( _actualPath );
                    showFilesInListView(_actualPath);
                    setFileWatcher(_actualPath);
                    TabItemIsActiv();
                }
                else {
                    _fsw.EnableRaisingEvents = false;
                }
            }
        }

        private void setFileWatcher(String actualPath) {
            if (actualPath.Length > 0) {
                _fsw.Path = actualPath;
                _fsw.Filter = "*.*";
                _fsw.EnableRaisingEvents = true;
            }
        }

        // public MyListView(Window parent, MyTabItem tabitem, String path, Image im_dir, Image im_file, Konstanten.setFilenamePath sFP) {

        


        public MyListView(Form parent, TabControl tabControl, TabPage tabitem, String path, ImageList imageListSmall, ImageList imageListBig, Konstanten.setFilenamePath sFP) {
            
            _tabControl = tabControl;
            _tabitem = tabitem;
            
            _parent = parent;
            _parentClass = (IFileManager)parent;
            this.sFP = sFP;

            LargeImageList = imageListSmall;
            SmallImageList = imageListBig;

            _fsw = new System.IO.FileSystemWatcher();
            _fsw.Changed += new System.IO.FileSystemEventHandler(this.FSW_Changed);
            _fsw.Created += new System.IO.FileSystemEventHandler(this.FSW_Created);
            _fsw.Deleted += new System.IO.FileSystemEventHandler(this.FSW_Deleted);
            _fsw.Renamed += new System.IO.RenamedEventHandler(this.FSW_Renamed);

            setGUI();
            setPopupMenu();
            ActualPath = path;

            ColumnClick += new System.Windows.Forms.ColumnClickEventHandler(fileTable1_ColumnClick);
            SelectedIndexChanged += new System.EventHandler(fileTable1_SelectedIndexChanged);
            DoubleClick += new System.EventHandler(fileTable1_DoubleClick);
            KeyDown += new System.Windows.Forms.KeyEventHandler(fileTable1_KeyDown);

            this.AllowDrop = true;
            MouseDown += new System.Windows.Forms.MouseEventHandler(listView_MouseDown);
            MouseMove += new System.Windows.Forms.MouseEventHandler(listView_MouseMove);
            MouseUp += new System.Windows.Forms.MouseEventHandler(listView_MouseUp);
            DragDrop += new System.Windows.Forms.DragEventHandler(listView_DragDrop);
            DragEnter += new System.Windows.Forms.DragEventHandler(listView_DragEnter);

        }  // setGUI

        // 1.
        int dragDropStartX = -1;
        int dragDropStartY = -1;
        bool dragDropMousedown = false;
        bool dragDropCopy = false;
        private void listView_MouseDown(object sender, MouseEventArgs e) {
            if (e.Button == MouseButtons.Left) {
                dragDropMousedown = true;
            }
            dragDropStartX = e.X;
            dragDropStartY = e.Y;
        }


        private void listView_MouseUp(object sender, MouseEventArgs e) {
            dragDropStartX = -1;
            dragDropStartY = -1;
            dragDropMousedown = false;
        }


        private void listView_MouseMove(object sender, MouseEventArgs e) {
            ListViewItem lv_item;

            // SystemParameters.MinimumHorizontalDragDistance
            // SystemParameters.MinimumVerticalDragDistance
            if (dragDropMousedown) {
                if ((dragDropStartX != -1) && (dragDropStartY != -1) &&
                    (System.Math.Abs(dragDropStartX - e.X) + System.Math.Abs(dragDropStartY - e.Y) > 4) && (this.SelectedItems.Count > 0)) {
                    int n = 0;
                    foreach (var selectedItem in this.SelectedItems) {
                        lv_item = (ListViewItem)selectedItem;
                        if (lv_item.Tag != null) {
                            FileItem fitem = (FileItem)lv_item.Tag;
                            if (fitem.Fullname != Konstanten.C_TOP_DIR) {
                                n++;
                            }
                        }
                    }
                    String[] files = new String[n];
                    int i = 0;
                    foreach (var selectedItem in this.SelectedItems) {
                        lv_item = (ListViewItem)selectedItem;
                        if (lv_item.Tag != null) {
                            FileItem fitem = (FileItem)lv_item.Tag;
                            if (fitem.Fullname != Konstanten.C_TOP_DIR) {
                                files[i] = fitem.Fullname;
                                i++;
                            }
                        }
                    }

                    var dataObject = new DataObject(DataFormats.FileDrop, files);
                    dataObject.SetData(DataFormats.StringFormat, dataObject);

                    Middleware instance = Middleware.getInstance();
                    instance.dragDropListview = this;
                    DoDragDrop(dataObject, DragDropEffects.Copy | DragDropEffects.Move);
                }
            }
        }


        // 2.
        private void listView_DragEnter(object sender, DragEventArgs e) {
            e.Effect = DragDropEffects.Copy;
            // if (e.Data.GetDataPresent(DataFormats.FileDrop))
            if (e.Data.GetDataPresent(DataFormats.FileDrop))  // FileDrop  oder Text
            {
                Middleware instance = Middleware.getInstance();
                if (instance.dragDropListview == this) {
                    e.Effect = DragDropEffects.None;
                }
                else {
                    switch (MyRegistry.CopymoveAction) {
                        case Konstanten.CopyMove.Dialog:
                                e.Effect = DragDropEffects.Copy;
                                return;
                        case Konstanten.CopyMove.Strg_Copy: 
                            switch (Control.ModifierKeys) {
                                case Keys.Control: e.Effect = DragDropEffects.Copy;
                                    dragDropCopy = true;
                                    return;
                                default: e.Effect = DragDropEffects.Move;  
                                    dragDropCopy = false;
                                    return;
                            }
                        case Konstanten.CopyMove.Strg_Move:
                            switch (Control.ModifierKeys) {
                                case Keys.Control: e.Effect = DragDropEffects.Move;
                                    dragDropCopy = false;
                                    return;
                                default: e.Effect = DragDropEffects.Copy;  
                                    dragDropCopy = true;
                                    return;
                            }
                    }
                }
                // e.Effect = DragDropEffects.Move;  // in quelle löschen
            }
            else {
                e.Effect = DragDropEffects.None;
            }
        }



        // 3.
        private void listView_DragDrop(object sender, DragEventArgs e) {
            Middleware instance = Middleware.getInstance();
            if (instance.dragDropListview != this) {

                string[] fileList = (string[])e.Data.GetData(DataFormats.FileDrop, false);
                //String item = e.Data.GetData(DataFormats.Text).ToString();
                //String[] items = item.Split('\t');
                // this._actualPath
                // dragDropCopy
                if (fileList.Length == 0) return;

                if (MyRegistry.CopymoveAction == Konstanten.CopyMove.Dialog) {
                    FCopyMoveDialog dialog = new FCopyMoveDialog(_parent, Basis.getPath(fileList[0]), ActualPath);
                    dialog.ShowDialog();
                    switch (dialog.retCode) {
                        case -1: return;
                        case 1: dragDropCopy = true;
                            break;
                        case 2: dragDropCopy = false;
                            break;
                    }

                }

                insertSelectedFiles(FileOperationAPIWrapper.FileOperationType.FO_COPY);


                StringBuilder files = new StringBuilder();
                foreach (String list_item in fileList) {
                    if (list_item.Length > 0) {
                        files.Append(list_item).Append("\0");
                    }
                }

                String actionFileString = files.ToString();
                if (dragDropCopy)
                    FileOperationAPIWrapper.FilesAction(actionFileString, _actualPath, FileOperationAPIWrapper.FileOperationType.FO_COPY,
                        FileOperationAPIWrapper.FileOperationFlags.FOF_ALLOWUNDO);
                else
                    FileOperationAPIWrapper.FilesAction(actionFileString, _actualPath, FileOperationAPIWrapper.FileOperationType.FO_MOVE,
                        FileOperationAPIWrapper.FileOperationFlags.FOF_ALLOWUNDO);
            }
            else {
                instance.dragDropListview = null;
            }
        }




        private void setPopupMenu() {
            contextMenuStrip = new ContextMenuStrip();
            this.ContextMenuStrip = contextMenuStrip;
            _mnMainProg = new ToolStripMenuItem();
            _mnMainProg.Text = "Eigene Programme";
            _mnMainProg.Tag = null;
            contextMenuStrip.Items.Add(_mnMainProg);

            contextMenuStrip.Items.Add(new ToolStripSeparator());

            //_mnMainFavoriten = new ToolStripMenuItem();
            //_mnMainFavoriten.Text = "Wechsel zu Favoriten";
            //_mnMainFavoriten.Tag = null;
            //contextMenuStrip.Items.Add(_mnMainFavoriten);

            //contextMenuStrip.Items.Add(new ToolStripSeparator());


            ToolStripMenuItem mn = new System.Windows.Forms.ToolStripMenuItem();
            mn.Text = "Ausschneiden";
            mn.Tag = null;
            contextMenuStrip.Items.Add(mn);
            mn.Click += cut_Click;

            mn = new ToolStripMenuItem();
            mn.Text = "Kopieren";
            mn.Tag = null;
            contextMenuStrip.Items.Add(mn);
            mn.Click += copy_Click;

            mn = new ToolStripMenuItem();
            mn.Text = "Löschen";
            mn.Tag = null;
            contextMenuStrip.Items.Add(mn);
            mn.Click += delete_Click;

            mn = new ToolStripMenuItem();
            mn.Text = "Einfügen";
            mn.Tag = null;
            contextMenuStrip.Items.Add(mn);
            mn.Click += paste_Click;

            contextMenuStrip.Items.Add(new ToolStripSeparator());

            mn = new ToolStripMenuItem();
            mn.Text = "Laufswerks-Informationen";
            mn.Tag = null;
            contextMenuStrip.Items.Add(mn);
            mn.Click += drive_info_Click;

            contextMenuStrip.Items.Add(new ToolStripSeparator());


            mn = new ToolStripMenuItem();
            mn.Text = "Eigenschaften";
            mn.Tag = null;
            contextMenuStrip.Items.Add(mn);
            mn.Click += property_Click;

            setContextMenu();
        }

        public void setContextMenu() {
            setContextMenu(Basis.getProgPath() + Konstanten.C_PROGS, _mnMainProg, true);
            // setContextMenu(Basis.getProgPath() + Konstanten.C_FAVORITEN, _mnMainFavoriten, false);
        }

        public void setContextMenu(String filename, ToolStripMenuItem mnMain, bool prog) {
            ToolStripMenuItem mnItem;
            String filepath, name;
            mnMain.DropDownItems.Clear();
            if (File.Exists(filename)) {
                String[] items = File.ReadAllLines(filename);
                int i = 0;
                while (i < items.Length) {
                    if (items[i].Length > 0) {
                        mnItem = new ToolStripMenuItem();
                        name = items[i];
                        i++;
                        filepath = items[i];
                        i++;
                        mnItem.Text = name;
                        mnItem.Tag = filepath;
                        mnMain.DropDownItems.Add(mnItem);
                        if (prog)
                            mnItem.Click += prog_ctm_Click;
                        else
                            mnItem.Click += favoriten_ctm_Click;
                    }
                    else {
                        i++;
                        i++;
                    }
                }
            }
        }  // setContextMenu

        private void favoriten_ctm_Click(object sender, EventArgs e) {
            ToolStripMenuItem mnProg = (ToolStripMenuItem)sender;
            String path = (String)mnProg.Tag;
            if (Directory.Exists(path)) {
                ActualPath = path;
            }
        }
        private void prog_ctm_Click(object sender, EventArgs e) {
            ToolStripMenuItem mnProg = (ToolStripMenuItem)sender;
            String program = (String)mnProg.Tag;
            if (File.Exists(program)) {
                FileItem fitem = getActiveFileItem();
                if (fitem != null && !fitem.Directory) {
                    Process Prog = new Process();
                    Prog.StartInfo.FileName = "\"" + program + "\"";
                    Prog.StartInfo.Arguments = "\"" + fitem.Fullname + "\"";
                    Prog.Start();
                }
            }
        }



        private void cut_Click(object sender, EventArgs e) {
            this.Cut();
        }
        private void copy_Click(object sender, EventArgs e) {
            this.Copy();
        }

        private void delete_Click(object sender, EventArgs e) {
            this.DeleteFiles(true);
        }

        private void paste_Click(object sender, EventArgs e) {
            this.Paste();
        }



        private void drive_info_Click(object sender, EventArgs e) {
            _parentClass.showDriveInfo(_actualPath.Substring(0, 3));  // example: c:\\
        }

        private void property_Click(object sender, EventArgs e) {
            FileItem fitem = getActiveFileItem();
            if (fitem != null) {
                FProperty dialog = new FProperty(_parent, fitem.Fullname);
                dialog.ShowDialog();
            }
        }

        void FSW_Renamed(object sender, RenamedEventArgs e) {
            filewatch();
        }
        void FSW_Deleted(object sender, FileSystemEventArgs e) {
            filewatch();
        }
        void FSW_Created(object sender, FileSystemEventArgs e) {
            filewatch();
        }
        void FSW_Changed(object sender, FileSystemEventArgs e) {
            filewatch();
        }

        delegate void showFilesInListViewCallback(string actualPath);

        private void filewatch() {            
            // Application.Current.Dispatcher.Invoke(new Action(() => { showFilesInListView(_actualPath); }));  // WPF
            this.Invoke(new Action(() => { showFilesInListView(_actualPath); }));
        }




        private void setGUI() {
            View = View.Details;		// Report vs. Details
            LabelEdit = false;		// EditModus
            AllowColumnReorder = true;	// Spalten verschieben
            CheckBoxes = false;		// CheckBox
            FullRowSelect = true;		// zeilenweise markieren
            GridLines = true;		// Gitterlinien

            Sorting = SortOrder.None;	// Sortiere (Alphanumerisch oder separat)
            // Spalten
            Columns.Add("Dateiname", 100, HorizontalAlignment.Left);
            Columns.Add("Ext", 50, HorizontalAlignment.Left);
            Columns.Add("Größe", 60, HorizontalAlignment.Left);
            Columns.Add("Letztes Schreiben", 80, HorizontalAlignment.Center);

        }  // setGUI

        private void fileTable1_SelectedIndexChanged(object sender, EventArgs e) {
            SelectionChanged();
        }

        // Click-Methods  Focus
        public void SelectionChanged() {
            if (!_abcChange) {
                _abc = ' ';
            }
            FileItem fitem = getActiveFileItem();
            if (fitem != null) {
                if (fitem != null) {
                    sFP(_actualPath, fitem.Fullname, _tabControl, _tabitem, this);  // focusTable
                }
                else {
                    sFP(_actualPath, "", _tabControl, _tabitem, this);
                }
            }
        }
        private void fileTable1_DoubleClick(object sender, EventArgs e) {
            MMouseDoubleClick();
        }

        private void fileTable1_ColumnClick(object sender, ColumnClickEventArgs e) {
            CColumnClick(e); // ColumnClickEventArgs e
        }

        private void fileTable1_KeyDown(object sender, KeyEventArgs e) {
            if (!e.Alt && !e.Control && !e.Shift && e.KeyValue == 13) {
                MMouseDoubleClick();
            }
            if (e.KeyValue == 46) {  // Key.Delete
                if (e.Shift)
                    DeleteFiles(false);
                else 
                    DeleteFiles(true);  // with recycleBin
                return;
            }
        }




        private void showFilesInListView(String path) {
            if (path == null) {
                return; // Hauptpunkte à la Anwender, Favoriten, Laufwerke
            }
            this.BeginUpdate();
            Items.Clear();
            _fileliste.Clear();
            _actualPath = path;
            // at fist, get the subdirs
            String[] dirs = Directory.GetDirectories(path);

            ListViewItem item1;
            FileItem fitem;
            if (_actualPath.Length > 3) {

                fitem = new FileItem(true);  // directory
                fitem.Fullname = Konstanten.C_TOP_DIR;
                fitem.Filename = Konstanten.C_TOP_DIR;
                fitem.Size = 0;
                fitem.Ext = "";
                item1 = new ListViewItem(Konstanten.C_TOP_DIR, 0);
                item1.Checked = false;
                item1.SubItems.Add("");  // ext
                item1.SubItems.Add("");  // size
                item1.SubItems.Add("");  // lastIme
                item1.Tag = fitem;
                item1.ImageIndex = 0;
                Items.Add(item1);
                _fileliste.Add(fitem);

            }

            foreach (String item in dirs) {
                DirectoryInfo dir = new DirectoryInfo(item);
                FileAttributes attribs = dir.Attributes;
                if ((attribs & FileAttributes.Hidden) != FileAttributes.Hidden && (attribs & FileAttributes.System) != FileAttributes.System) {
                    fitem = new FileItem(true);  // is directory
                    fitem.Fullname = dir.FullName;
                    fitem.Filename = dir.Name;
                    fitem.Size = 0;
                    fitem.Ext = "";
                    fitem.LastTime = dir.LastWriteTime;  //  dir.LastAccessTime;
                    fitem.CreateTime = dir.LastWriteTime;

                    item1 = new ListViewItem(fitem.Filename, 0);
                    item1.Checked = false;
                    item1.SubItems.Add(fitem.Ext);  // ext
                    item1.SubItems.Add("");  // size
                    item1.SubItems.Add("");  // lastIme
                    item1.Tag = fitem;
                    item1.ImageIndex = 0;
                    Items.Add(item1);
                    _fileliste.Add(fitem);
                }
            }
            // next, get the files

            DirectoryInfo mainDir = new DirectoryInfo(_actualPath);
            // String[] files = Directory.GetFiles(path);
            String[] masken = Middleware.getMasks(_aktmask, _OwnerDefined);
            foreach (String maske in masken) {
                FileInfo[] files = mainDir.GetFiles(maske, SearchOption.TopDirectoryOnly);
                foreach (FileInfo file in files) {
                    String item = file.FullName;
                    FileInfo dir = new FileInfo(item);
                    FileAttributes attribs = dir.Attributes;
                    if ((attribs & FileAttributes.Hidden) != FileAttributes.Hidden && (attribs & FileAttributes.System) != FileAttributes.System) {
                        fitem = new FileItem(false);  // no directory
                        fitem.Fullname = dir.FullName;
                        fitem.Filename = dir.Name;
                        fitem.Ext = dir.Extension;
                        fitem.Size = dir.Length;
                        fitem.LastTime = dir.LastWriteTime;  //  dir.LastAccessTime;
                        fitem.CreateTime = dir.LastWriteTime;


                        item1 = new ListViewItem(fitem.Filename, 1);
                        item1.SubItems.Add(fitem.Ext);  // ext
                        item1.SubItems.Add(fitem.StringSize);  // size
                        item1.SubItems.Add(fitem.CreateTime.ToString());  // lastIme
                        item1.Checked = true;  //  StateImageList
                        item1.Tag = fitem;
                        item1.ImageIndex = 1;
                        Items.Add(item1);
                        _fileliste.Add(fitem);
                    }
                }
            }
            this.EndUpdate();
        }  // showFilesinListView


       

        private FileItem getActiveFileItem() {
            ListView.SelectedListViewItemCollection items = SelectedItems;
            if (items.Count == 0) return null;
            ListViewItem item = (ListViewItem)items[0];
            if (item != null)
                return (FileItem)item.Tag;
            else
                return null;
        }

        // ListList
        public void MMouseDoubleClick() {
            FileItem fitem = getActiveFileItem();
            if (fitem == null) return;
            if (fitem.Directory) {
                if (fitem.Fullname.Equals(Konstanten.C_TOP_DIR)) {
                    DirectoryInfo directoryInfo;
                    if (_actualPath.EndsWith("\\"))
                        directoryInfo = new DirectoryInfo(_actualPath + "..");
                    else
                        directoryInfo = new DirectoryInfo(_actualPath + "\\..");
                    _actualPath = directoryInfo.FullName;
                }
                else {
                    _actualPath = (String)fitem.Fullname;
                }
                showFilesInListView(_actualPath);
                setFileWatcher(_actualPath);
                sFP(_actualPath, "", _tabControl, _tabitem, this);
            }
            else {
                // if USB-Sticker is removed
                if (File.Exists(fitem.Fullname)) {
                    Process Prog = new Process();
                    Prog.StartInfo.FileName = fitem.Fullname;   // C:\\Daten\test.txt
                    Prog.StartInfo.Arguments = "";
                    Prog.Start();
                }
            }
        }  // MouseDoubleClick


        //xxx

        public String OwnerDefined {
            set { _OwnerDefined = value; }
        }

        public void setMask(Middleware.Masken mask) {
            _aktmask = mask;
            showFilesInListView(_actualPath);
        }


        public void TabItemIsActiv() {
            FileItem fitem = getActiveFileItem();
            if (fitem != null) {
                sFP(_actualPath, fitem.Fullname, _tabControl, _tabitem, this);
            }
            else {
                sFP(_actualPath, "", _tabControl, _tabitem, this);
            }
            _parentClass.setActualMask(_aktmask, _OwnerDefined);
        }



        public void GoToRoot() {
            if (_actualPath.Length > 3) {
                _actualPath = _actualPath.Substring(0, 3);
                showFilesInListView(_actualPath);
            }
        }
        public void GoToTopFolder() {
            if (_actualPath.Length > 3) {
                DirectoryInfo directoryInfo;
                if (_actualPath.EndsWith("\\"))
                    directoryInfo = new DirectoryInfo(_actualPath + "..");
                else
                    directoryInfo = new DirectoryInfo(_actualPath + "\\..");
                _actualPath = directoryInfo.FullName;
                showFilesInListView(_actualPath);
            }
        }


        public void FSW_Click() {
            showFilesInListView(_actualPath);
        }


        private void insertSelectedFiles(FileOperationAPIWrapper.FileOperationType action) {
            ListView.SelectedListViewItemCollection items = SelectedItems;
            if (items.Count > 0) {
                ArrayList liste = new ArrayList();
                foreach (ListViewItem selectedItem in items) {
                    FileItem fitem = (FileItem)selectedItem.Tag;
                    liste.Add(fitem.Fullname);
                }
                _middleware.insertSelectedFiles(liste, action);
            }
            else {
                // Basis.ErrorMsg("Sie haben keine Dateien/Verzeichnisse ausgewählt", "Hinweis");
            }
        }  // insertSelectedFiles

        public void Copy() {
            insertSelectedFiles(FileOperationAPIWrapper.FileOperationType.FO_COPY);
        }
        public void Cut() {
            insertSelectedFiles(FileOperationAPIWrapper.FileOperationType.FO_MOVE);
            showFilesInListView(_actualPath);
            _parentClass.insertSubDirsIntoTree(_actualPath, true);
        }
        public void Paste() {
            FileOperationAPIWrapper.FileOperationType fileop;
            String actionFileString = "";
            int action = _middleware.getSelectedFilesFromRegistry(out actionFileString);
            switch (action) {
                case 1: fileop = FileOperationAPIWrapper.FileOperationType.FO_MOVE; break;
                case 2: fileop = FileOperationAPIWrapper.FileOperationType.FO_COPY; break;
                default: return;  // action=0
            }
            FileOperationAPIWrapper.FilesAction(actionFileString, _actualPath, fileop, FileOperationAPIWrapper.FileOperationFlags.FOF_ALLOWUNDO);

            _parentClass.insertSubDirsIntoTree(_actualPath, true);
            showFilesInListView(_actualPath);
        }


        public void DeleteFiles(bool recycleBin) {
            FileOperationAPIWrapper.FileOperationType fileop = FileOperationAPIWrapper.FileOperationType.FO_DELETE;
            String actionFileString = getSelectedFiles_Delete();
            if (actionFileString.Length > 0) {
                if (recycleBin)
                    FileOperationAPIWrapper.FilesAction(actionFileString, _actualPath, fileop, FileOperationAPIWrapper.FileOperationFlags.FOF_ALLOWUNDO);
                else
                    FileOperationAPIWrapper.FilesAction(actionFileString, _actualPath, fileop, 0);
                showFilesInListView(_actualPath); // FileWatcher             
                _parentClass.insertSubDirsIntoTree(_actualPath, true);
            }

        }  // deleteFiles


        // ddddd
        private String getSelectedFiles_Delete() {
            System.Collections.ICollection items = SelectedItems;
            if (items.Count > 0) {
                StringBuilder files = new StringBuilder();
                foreach (ListViewItem selectedItem in items) {
                    FileItem fitem = (FileItem)selectedItem.Tag;    
                    files.Append(fitem.Fullname).Append("\0");
                }
                return files.ToString();
            }
            else {
                Basis.ErrorMsg("Sie haben keine Dateien/Verzeichnisse ausgewählt", "Hinweis");
                return "";
            }
        }  // getSelectedFiles_Delete


        public void SelectAllItems() {
            foreach (ListViewItem item in Items) {
                item.Selected = true;
            }
        }

        public void CopyF8() {
            FileItem fitem = getActiveFileItem();
            if (fitem != null && !fitem.Directory) {
                String path;
                String filename;
                Basis.splitFilename(fitem.Fullname, out path, out filename);
                FCopyWindow dialog = new FCopyWindow(_parent, filename);
                dialog.ShowDialog();
                if (dialog.Retcode) {
                    String newFilename = path + dialog.TBis;
                    if (File.Exists(newFilename)) {
                        File.Delete(newFilename);
                    }
                    System.IO.File.Copy(fitem.Fullname, newFilename);
                    showFilesInListView(_actualPath);
                }
            }
        }

        public void RenameF2() {
            FileItem fitem = getActiveFileItem();
            if (fitem != null) {
                String path;
                String filename;
                Basis.splitFilename(fitem.Fullname, out path, out filename);
                FRenameWindow dialog = new FRenameWindow(_parent, filename, fitem.Directory);
                dialog.ShowDialog();
                if (dialog.Retcode) {
                    String newfile = dialog.TBis;
                    String newFilename;
                    if (newfile.IndexOf("\\") >= 0)
                        newFilename = newfile;
                    else
                        newFilename = path + newfile;
                    if (fitem.Directory) {
                        DirectoryInfo di = new DirectoryInfo(fitem.Fullname);
                        di.MoveTo(System.IO.Path.Combine(di.Parent.FullName, newFilename));
                    }
                    else {
                        System.IO.File.Move(fitem.Fullname, newFilename);
                    }
                    showFilesInListView(_actualPath);
                }
            }
        }


        public void RunHexEditor() {
            String program = Basis.getProgPath() + "Hexeditor.exe";
            FileItem fitem = getActiveFileItem();
            if (fitem != null && !fitem.Directory) {
                if (File.Exists(program)) {
                    Process Prog = new Process();
                    Prog.StartInfo.FileName = program;
                    Prog.StartInfo.Arguments = "\"" + fitem.Fullname + "\"";
                    Prog.Start();
                }
                else {
                    Basis.ErrorMsg("Der HexEditor ist nicht vorhanden\r\n" + program, "Fehler");
                }
            }
        }

        public void RunNotepad() {
            FileItem fitem = getActiveFileItem();
            if (fitem != null && !fitem.Directory) {
                Process Prog = new Process();
                Prog.StartInfo.FileName = "notepad.exe";
                Prog.StartInfo.Arguments = "\"" + fitem.Fullname + "\"";
                Prog.Start();
            }
        }

        public void RunEditor5000() {
            FileItem fitem = getActiveFileItem();
            if (fitem != null && !fitem.Directory) {
                Process Prog = new Process();
                Prog.StartInfo.FileName = Basis.getProgPath() + "Editor5000.exe";
                Prog.StartInfo.Arguments = "\"" + fitem.Fullname + "\"";
                Prog.Start();
            }
        }



        public void DosEbene() {
            Process Prog = new Process();
            Prog.StartInfo.FileName = "CMD.exe";
            Prog.StartInfo.Arguments = "";
            Prog.StartInfo.WorkingDirectory = _actualPath;  // !!!
            Prog.Start();
        }

        public void Path2Clipboard() {
            FileItem fitem = getActiveFileItem();
            if (fitem != null) {
                Clipboard.SetDataObject(fitem.Fullname);
            }
        }
        public void LoadAgain() {
            // insertDrives(_mainNodeDrives);
            if (!_actualPath.Equals("")) showFilesInListView(_actualPath);
        }


        public void ShowAllFiles() {
            FileItem fitem = getActiveFileItem();
            if (fitem != null) {
                if (fitem.Directory) {
                    createFilesRekursiv(fitem.Fullname);
                }
            }
        }


        private void createFilesRekursiv(String dirFilename) {
            StringBuilder erg = new StringBuilder();

            long gesamtsumme = 0;
            long summe = 0;
            String lastdir = "";
            // this.Cursor = Cursors.Wait;
            
                String[] files = Directory.GetFiles(dirFilename, "*.*", SearchOption.AllDirectories);
                foreach (String filename in files) {
                    String path = Basis.getPath(filename);
                    if (lastdir.Equals("")) erg.Append(path + "\r\n");
                    if (!lastdir.Equals("") && !path.Equals(lastdir)) {
                        erg.Append("   Summe: " + Basis.Best_KB(summe) + ", " + Basis.Long_Str_Komma(summe) + " Bytes\r\n\r\n");
                        summe = 0;
                        erg.Append(path + "\r\n");
                    }
                    FileInfo fi = new FileInfo(filename);
                    summe += fi.Length;
                    gesamtsumme += fi.Length;
                    erg.Append("   " + Basis.getFilename(filename) + ", " + Basis.Best_KB(fi.Length) + "\r\n");
                    lastdir = path;
                }
                erg.Append("Summe: " + Basis.Best_KB(summe) + ", " + Basis.Long_Str_Komma(summe) + " Bytes\r\n\r\n");
                erg.Append("Gesamtsumme: " + Basis.Best_KB(gesamtsumme) + ", " + Basis.Long_Str_Komma(gesamtsumme) + " Bytes");
            // this.Cursor = Cursors.Arrow;


            FEditor dialog = new FEditor(erg.ToString());
            dialog.Show();
        }

        public void CompareFolders(String actualPath, List<FileItem> fileliste2) {
            List<FileItem> equal = new List<FileItem>();
            List<FileItem> sizeNotEqual1 = new List<FileItem>();
            List<FileItem> sizeNotEqual2 = new List<FileItem>();
            List<FileItem> timeNotEqual = new List<FileItem>();
            List<FileItem> notinListe1 = new List<FileItem>();
            List<FileItem> notinListe2 = new List<FileItem>();
            // _fileliste  mit fileliste2
                foreach (FileItem item1 in _fileliste) {
                    bool gefunden = false;
                    foreach (FileItem item2 in fileliste2) {
                        if (item1.Filename.Equals(item2.Filename)) {
                            gefunden = true;
                            if (item1.Size != item2.Size) {
                                sizeNotEqual1.Add(item1);
                                sizeNotEqual2.Add(item2);
                            }
                            else {
                                if (item1.LastTime != item2.LastTime) {
                                    timeNotEqual.Add(item1);
                                }
                                else {
                                    if (item1.Filename != Konstanten.C_TOP_DIR) {
                                        equal.Add(item1);
                                    }
                                }
                            }
                        }
                    }
                    if (!gefunden) {
                        notinListe2.Add(item1);
                    }
                }
                foreach (FileItem item2 in fileliste2) {
                    bool gefunden = false;
                    foreach (FileItem item1 in _fileliste) {
                        if (item2.Filename.Equals(item1.Filename)) {
                            gefunden = true;
                        }
                    }
                    if (!gefunden) {
                        notinListe1.Add(item2);
                    }
                }
            StringBuilder erg = new StringBuilder();
            erg.Append("Linke Liste:" + _actualPath + "\r\n");
            erg.Append("Rechte Liste:" + actualPath + "\r\n\r\n\r\n");


            if (notinListe2.Count > 0) {
                erg.Append("Dateien, die nur in linker Liste sind:\r\n");
                foreach (FileItem item in notinListe2) {
                    erg.Append("  " + item.Filename + "\r\n");
                }
            }
            else {
                erg.Append("Es gibt keine Dateien, die nur in linker Liste sind.\r\n\r\n\r\n");
            }
            erg.Append("\r\n\r\n");
            if (notinListe1.Count > 0) {
                erg.Append("Dateien, die nur in rechter Liste sind:\r\n");
                foreach (FileItem item in notinListe1) {
                    erg.Append("  " + item.Filename + "\r\n");
                }
            }
            else {
                erg.Append("Es gibt keine Dateien, die nur in rechter Liste sind.\r\n\r\n\r\n");
            }

            erg.Append("\r\n\r\n");
            if (sizeNotEqual1.Count > 0) {
                erg.Append("Dateien, deren Größe unterschiedlich ist:\r\n");
                for (int i = 0; i < sizeNotEqual1.Count; i++) {
                    FileItem item1 = sizeNotEqual1[i];
                    FileItem item2 = sizeNotEqual2[i];
                    erg.Append("  " + item1.Filename + ", " + Basis.Best_KB(item1.Size) + ", " + Basis.Best_KB(item2.Size) + "\r\n");
                }
            }
            else {
                erg.Append("Es gibt keine Dateien, deren Größe unterschiedlich ist.\r\n\r\n\r\n");
            }

            erg.Append("\r\n\r\n");
            if (timeNotEqual.Count > 0) {
                erg.Append("Dateien, deren Zeiten unterschiedlich sind:\r\n");
                foreach (FileItem item in timeNotEqual) {
                    erg.Append("  " + item.Filename + "\r\n");
                }
            }
            else {
                erg.Append("Es gibt keine Dateien, deren Zeiten unterschiedlich sind.\r\n\r\n\r\n");
            }

            erg.Append("\r\n\r\n");
            if (equal.Count > 0) {
                erg.Append("Dateien, die in beiden Listen gleich sind:\r\n");
                foreach (FileItem item in equal) {
                    erg.Append("  " + item.Filename + "\r\n");
                }
            }
            else {
                erg.Append("Es gibt keine Dateien, die in beiden Listen gleich sind.\r\n\r\n\r\n");
            }



            FEditor dialog = new FEditor(erg.ToString());
            dialog.Show();
        }  // CompareFolders


        public void NewFolder() {
            if (!_actualPath.Equals("")) {
                String path = _actualPath;
                if (!path.EndsWith("\\")) path += "\\";
                // Form parent, String title, String caption, String itemcaption, String tInput
                FReadString dialog = new FReadString(_parent, "Anlegen eines neuen Ordners", "Neuer Ordner", "Ordnername", "");
                dialog.ShowDialog();
                if (dialog.Retcode) {
                    String newDir = path + dialog.TInput;
                    System.IO.Directory.CreateDirectory(newDir);
                    showFilesInListView(_actualPath);
                    _parentClass.insertSubDirsIntoTree(_actualPath, true);
                }
            }
        } // NewFolder




        public void Suche(char abc) {
            if (_abc != abc) {
                _abcIndex = 0; // from start
            }
            FileItem fitem;
            for (int i = _abcIndex; i < this._fileliste.Count; i++) {
                fitem = _fileliste[i];
                char c = fitem.Filename.ToUpper()[0];
                if (c == abc) {
                    _abcChange = true;
                    foreach (ListViewItem item in Items) {
                        item.Selected = false;
                    }
                    Items[i].Selected = true; // scrolling is automatic
                    _abcIndex = i + 1;
                    _abc = abc;
                    _abcChange = false;
                    break;
                }
            } // for
        } // suche


        ListSortDirection _lastDirection = ListSortDirection.Ascending;

        public void CColumnClick(ColumnClickEventArgs e) {
            ListSortDirection direction;
            _headerClicked = e.Column;
            if (_headerClicked != _lastHeaderClicked) {
                direction = ListSortDirection.Ascending;
            }
            else {
                if (_lastDirection == ListSortDirection.Ascending) {
                    direction = ListSortDirection.Descending;
                }
                else {
                    direction = ListSortDirection.Ascending;
                }
            }
            FileItem.direction = direction;
            _lastHeaderClicked = _headerClicked;
            _lastDirection = direction;

            switch (_headerClicked) {
                case 0: FileItem.sortType = FileItem.FileinfoTyp.Name; break;
                case 1: FileItem.sortType = FileItem.FileinfoTyp.Ext; break;
                case 2: FileItem.sortType = FileItem.FileinfoTyp.Size; break;
                case 3: FileItem.sortType = FileItem.FileinfoTyp.LastTime; break;
                default: return;  // image
            }
            _fileliste.Sort();  // sort in an external Array
            //BeginInit();
            Items.Clear();  // insert in the ListView
            ListViewItem item1;
            foreach (FileItem fitem in _fileliste) {
                item1 = new ListViewItem(fitem.Filename, 1);
                item1.SubItems.Add(fitem.Ext);  // ext
                item1.SubItems.Add(fitem.StringSize);  // size
                item1.SubItems.Add(fitem.CreateTime.ToString());  // lastIme
                item1.Checked = true;  //  StateImageList
                item1.Tag = fitem;
                Items.Add(item1);
            }
            // EndInit();
        }




    }
}
